﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace ComboInGridTest
{
    public partial class Form1 : Form
    {
        DataTable gridCityTable;
        DataTable comboCityTable;

        public Form1()
        {
            InitializeComponent();
            
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraDropDown1.DataSource = buildComboCityTable();
            ultraDropDown1.DisplayMember = "City";
            ultraDropDown1.ValueMember = "CityID";
            ultraGrid1.DataSource = buildGridCityTable();
            ultraGrid1.DisplayLayout.AutoFitStyle = AutoFitStyle.ResizeAllColumns;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns[0].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList;
            e.Layout.GroupByBox.Hidden = true;
            e.Layout.Bands[0].Columns[0].Header.Caption = "City ID";
            e.Layout.Bands[0].Columns[1].AutoCompleteMode = Infragistics.Win.AutoCompleteMode.Suggest;
            e.Layout.Bands[0].Columns[1].AutoSuggestFilterMode = AutoSuggestFilterMode.Contains;
            
            ultraGrid1.Text = "City Grid ©";

            //ultraCombo1.DataSource = buildComboCityTable();
            //e.Layout.Bands[0].Columns["City"].EditorComponent = ultraCombo1;

            e.Layout.Bands[0].Columns["City"].ValueList = ultraDropDown1;
            ultraGrid1.Font = new Font("Microsoft Sans Serif", 10.25F);
            e.Layout.Override.RowSelectors = DefaultableBoolean.True;
            e.Layout.Override.ActiveRowAppearance.BackColor = Color.Brown;
            e.Layout.Override.HeaderAppearance.BackColor = Color.LightBlue;
            e.Layout.Override.HeaderStyle = HeaderStyle.Standard;
            e.Layout.Override.HeaderAppearance.FontData.Bold = DefaultableBoolean.True;
            e.Layout.Bands[0].Override.HeaderAppearance.TextHAlign = HAlign.Center;
            e.Layout.Override.RowSelectorAppearance.BackColor = Color.LightBlue;
            e.Layout.Override.BorderStyleCell = UIElementBorderStyle.InsetSoft;
        }

        private DataTable buildGridCityTable()
        {
            gridCityTable = new DataTable();
            gridCityTable.Columns.Add("CityID", typeof(int));
            gridCityTable.Columns.Add("City", typeof(string));
            gridCityTable.Columns.Add("State", typeof(string));
            gridCityTable.Rows.Add(new object[] { 1, "", ""});
            gridCityTable.Rows.Add(new object[] { 2, "", "" });
            gridCityTable.Rows.Add(new object[] { 3, "", "" });
            gridCityTable.Rows.Add(new object[] { 4, "", "" });
            gridCityTable.Rows.Add(new object[] { 5, "", "" });
            gridCityTable.Rows.Add(new object[] { 6, "", "" });
            gridCityTable.Rows.Add(new object[] { 7, "", "" });
            gridCityTable.Rows.Add(new object[] { 8, "", "" });
            gridCityTable.Rows.Add(new object[] { 9, "", "" });
            return gridCityTable;
        }

        private DataTable buildComboCityTable()
        {
            comboCityTable = new DataTable();
            comboCityTable.Columns.Add("CityID", typeof(int));
            comboCityTable.Columns.Add("City", typeof(string));
            comboCityTable.Columns.Add("State", typeof(string));
            comboCityTable.Columns.Add("Population", typeof(int));
            comboCityTable.Rows.Add(new object[] { 1, "New York", "NY", 8175133 });
            comboCityTable.Rows.Add(new object[] { 2, "Jersey City", "NJ", 247597 });
            comboCityTable.Rows.Add(new object[] { 3, "Newark", "NJ", 277140 });
            comboCityTable.Rows.Add(new object[] { 4, "Trenton", "NJ", 84913 });
            comboCityTable.Rows.Add(new object[] { 5, "Philadelphia", "PA", 1526006 });
            comboCityTable.Rows.Add(new object[] { 6, "Wilmington", "DE", 70851 });
            comboCityTable.Rows.Add(new object[] { 7, "Baltimore", "MD", 620961 });
            comboCityTable.Rows.Add(new object[] { 8, "Washington", "DC", 601723 });
            comboCityTable.Rows.Add(new object[] { 9, "Richmond", "VA", 204214 });
            return comboCityTable;
        }

        private void ultraCombo1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            //ultraCombo1.DisplayMember = "City";
            //ultraCombo1.ValueMember = "CityID";
            //ultraCombo1.AutoCompleteMode = Infragistics.Win.AutoCompleteMode.Suggest;
            //ultraCombo1.AutoSuggestFilterMode = AutoSuggestFilterMode.StartsWith;
            //ultraCombo1.DisplayLayout.Grid.Size = new System.Drawing.Size(160, 460);
            //ultraCombo1.DropDownStyle = UltraComboStyle.DropDown;
            //ultraCombo1.MaxDropDownItems = 10;
            //ultraCombo1.DisplayLayout.Bands[0].Columns["CityID"].Hidden = true;
            //ultraCombo1.DisplayLayout.Bands[0].Columns["State"].Hidden = true;
        }

        private void ultraGrid1_CellListSelect(object sender, CellEventArgs e)
        {
            //ultraGrid1.ActiveRow.Cells["State"].Value = ultraCombo1.SelectedRow.Cells["State"].Text;
            ultraGrid1.ActiveRow.Cells["State"].Value = ultraDropDown1.SelectedRow.Cells["State"].Text;
        }

        private void ultraGrid1_ClickCell(object sender, ClickCellEventArgs e)
        {

        }

        private void iterateButton_Click(object sender, EventArgs e)
        {
            foreach (UltraGridRow row in ultraGrid1.Rows)
            {
                foreach (UltraGridRow fila in ultraDropDown1.Rows)
                {
                    if (row.Cells["City"].Text == fila.Cells["City"].Text)
                    {
                        listView1.Items.Add(fila.Cells["Population"].Text);
                    }
                }
            }
        }
    }
}
